#include "scm.hpp"

/***********************************************************************************************************/
scm::scm(map < string, string > &args)
  : _mdom(0), _pdom(0)
{
  map < string, string > :: iterator maiter;
  
  if((maiter = args.find("setDim")) == args.end())
    die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg setDim");
  
  setDim = stringToInt(maiter->second);
  
  if((maiter = args.find("Psize")) == args.end())
    die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg Psize");
  
  _Psize = stringToInt(maiter->second);
  
  if((maiter = args.find("Msize")) == args.end())
    die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg Msize");
  
  _Msize = stringToInt(maiter->second);
  
  if((maiter = args.find("pd")) == args.end())
    die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg pd");
  
  _pd = stringToDouble(maiter->second);
  
  if((maiter = args.find("pa")) == args.end())
    die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg pa");
  
  _pa = stringToDouble(maiter->second);
  
  if((maiter = args.find("mua")) == args.end())
    die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg mua");
  
  _mua = stringToDouble(maiter->second);
  
  if((maiter = args.find("omega")) == args.end())
    die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg omega");
  
  _omega = stringToInt(maiter->second);
  
  if((maiter = args.find("t")) == args.end())
    die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg t");
  
  _t = stringToLong(maiter->second);
  
  if((maiter = args.find("Pgap")) == args.end())
    die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg Pgap");
  
  _Pgap = stringToInt(maiter->second);
  
  if((maiter = args.find("Mgap")) == args.end())
    die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg Mgap");
  
  _Mgap = stringToInt(maiter->second);
  
  if((maiter = args.find("maxProgSize")) == args.end())
    die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg maxProgSize");
  
  _maxProgSize = stringToInt(maiter->second);
  
  if((maiter = args.find("pBidDelete")) == args.end())
    die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg pBidDelete");
  
  _pBidDelete = stringToDouble(maiter->second);
  
  if((maiter = args.find("pBidAdd")) == args.end())
    die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg pBidAdd");
  
  _pBidAdd = stringToDouble(maiter->second);
  
  if((maiter = args.find("pBidSwap")) == args.end())
    die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg pBidSwap");
  
  _pBidSwap = stringToDouble(maiter->second);
  
  if((maiter = args.find("pBidMutate")) == args.end())
    die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg pBidMutate");
  
  _pBidMutate = stringToDouble(maiter->second);

  if((maiter = args.find("statMod")) == args.end())
    die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg statMod");
  
  _statMod = stringToLong(maiter->second);

  if((maiter = args.find("seed")) == args.end())
    die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg seed");
  
  _seed = stringToLong(maiter->second);
  
  cout << "arg Psize " << _Psize << endl;
  cout << "arg Msize " << _Msize << endl;
  cout << "arg pd " << _pd << endl;
  cout << "arg pa " << _pa << endl;
  cout << "arg mua " << _mua << endl;
  cout << "arg omega " << _omega << endl;
  cout << "arg t " << _t << endl;
  cout << "arg Pgap " << _Pgap << endl;
  cout << "arg Mgap " << _Mgap << endl;
  
  cout << "arg maxProgSize " << _maxProgSize << endl;
  cout << "arg pBidDelete " << _pBidDelete << endl;
  cout << "arg pBidAdd " << _pBidAdd << endl;
  cout << "arg pBidSwap " << _pBidSwap << endl;
  cout << "arg pBidMutate " << _pBidMutate << endl;
  
  cout << "arg statMod " << _statMod << endl;
  cout << "arg seed " << _seed << endl;
  
  if(_Psize < 2)
    die(__FILE__, __FUNCTION__, __LINE__, "bad arg Psize < 2");
  
  if(_Msize < 2)
    die(__FILE__, __FUNCTION__, __LINE__, "bad arg Msize < 2");
 
  if(_pd < 0 || _pd > 1)
    die(__FILE__, __FUNCTION__, __LINE__, "bad arg pd < 0 || pd > 1");

  if(_pa < 0 || _pa > 1)
    die(__FILE__, __FUNCTION__, __LINE__, "bad arg pa < 0 || pa > 1");
  
  if(_mua < 0 || _mua > 1)
    die(__FILE__, __FUNCTION__, __LINE__, "bad arg mua < 0 || mua > 1");
  
  if(_omega < 2)
    die(__FILE__, __FUNCTION__, __LINE__, "bad arg omega < 2");  
  
  if(_t < 1) 
    die(__FILE__, __FUNCTION__, __LINE__, "bad arg t < 1");  

  if(_Pgap < 1 || _Pgap >= _Psize)
    die(__FILE__, __FUNCTION__, __LINE__, "bad arg Pgap < 1 || Pgap >= Psize");

  if(_Mgap < 1 || _Mgap >= _Msize || _Mgap % 2 != 0)
    die(__FILE__, __FUNCTION__, __LINE__, "bad arg Mgap < 1 || Mgap >= Msize || Mgap % 2 != 0");
  
  if(_maxProgSize < 1)
    die(__FILE__, __FUNCTION__, __LINE__, "bad arg _maxProgSize < 1");  
  
  if(_pBidDelete < 0 || _pBidDelete > 1)
    die(__FILE__, __FUNCTION__, __LINE__, "bad arg pBidDelete < 0 || pBidDelete > 1");
  
  if(_pBidAdd < 0 || _pBidAdd > 1)
    die(__FILE__, __FUNCTION__, __LINE__, "bad arg pBidAdd < 0 || pBidAdd > 1");
  
  if(_pBidSwap < 0 || _pBidSwap > 1)
    die(__FILE__, __FUNCTION__, __LINE__, "bad arg pBidSwap < 0 || pBidSwap > 1");
  
  if(_pBidMutate < 0 || _pBidMutate > 1)
    die(__FILE__, __FUNCTION__, __LINE__, "bad arg pBidMutate < 0 || pBidMutate > 1");

  if(_statMod < 1)
    die(__FILE__, __FUNCTION__, __LINE__, "bad arg statMod < 1");    
}

/***********************************************************************************************************/

scm::~scm()
{
  
}

/***********************************************************************************************************/

void scm::initTeams()
{
  long a1, a2;
  team *m;
  learner *l;

  /* Number of teams to initialize. */
  int keep = _Msize - _Mgap;
  
  for(int tc = 0; tc < keep; tc++)
    {
      /* Get two different actions. */
      
      a1 = (long) (drand48() * numActions());
      
      do
	{
	  a2 = (long) (drand48() * numActions());
	} while (a1 == a2);
      
      /* Create a new team containing two learners. */
      
      m = new team(-1, setDim);
      
      l = new learner(-1, a1, _maxProgSize);
      m->addLearner(l); 
      l->refInc();
      L_.insert(l);
      
      l = new learner(-1, a2, _maxProgSize);
      m->addLearner(l);
      l->refInc();
      L_.insert(l);
      
      M_.insert(m);

#ifdef MYDEBUG
      cout << "scm::initTeams added " << *m << endl;
#endif
    }
}

/***********************************************************************************************************/

void scm::genTeams(long t)
{
  /* Parent teams. */
  vector < team * > parent;
  int size;
  
  team *p1, *p2;
  team *c1, *c2, *cx, *cy;
  
  /* Learner in parents. */
  set < learner * > plearners1;
  set < learner * > plearners2;

  /* Learners in children. */
  set < learner * > clearners1;
  set < learner * > clearners2;
    
  set < learner * > :: iterator leiter, leiterend;
  
  /* Set intersection and difference. */
  set < learner * > setinter;
  set < learner * > setdiff;
    
  set < team * > :: iterator teiter, teiterend;
  
  /* Get parent teams into vector. */

  for(teiter = M_.begin(), teiterend = M_.end(); 
      teiter != teiterend; teiter++)
    parent.push_back(*teiter);

  size = parent.size();

  while(M_.size() < _Msize)
    {
      /* Create two children for each pair of parents. */

      p1 = parent[(int) (drand48() * size)];
      
      do
	{
	  p2 = parent[(int) (drand48() * size)];
	} while(p1 == p2);
      
#ifdef MYDEBUG
      cout << "scm:genTeams " << t << " p1 "  << *p1 << " p2 " << *p2;
#endif
      
      /* Retrieve learners in parents. */

      plearners1.clear();
      plearners2.clear();
      p1->members(&plearners1);
      p2->members(&plearners2);

      /* Get intersection and difference. */

      setinter.clear();
      setdiff.clear();
      
      set_intersection(plearners1.begin(), plearners1.end(),
		       plearners2.begin(), plearners2.end(),
		       insert_iterator < set < learner * > > (setinter, setinter.begin()));
      
      set_symmetric_difference(plearners1.begin(), plearners1.end(),
			       plearners2.begin(), plearners2.end(),
			       insert_iterator < set < learner * > > (setdiff, setdiff.begin()));

#ifdef MYDEBUG
      cout << " inter";
      for(leiter = setinter.begin(); leiter != setinter.end(); leiter++)
	cout << " " << **leiter;
      cout << " diff";
      for(leiter = setdiff.begin(); leiter != setdiff.end(); leiter++)
	cout << " " << **leiter;
#endif
      
      /* Create offspring teams. */

      c1 = new team(t, setDim);
      c2 = new team(t, setDim);

      /* Add learners in inter to both offspring. */

      for(leiter = setinter.begin(), leiterend = setinter.end(); 
	  leiter != leiterend; leiter++)
	{
	  c1->addLearner(*leiter);
	  c2->addLearner(*leiter);
	}
	
      /* Add learners in diff to one of the offspring. */
      
      for(leiter = setdiff.begin(), leiterend = setdiff.end();
	  leiter != leiterend; leiter++)
	{
	  if(drand48() < 0.5)
	    { cx = c1; cy = c2; }
	  else
	    { cx = c2; cy = c1; }
	  
	  if((cx->size() < _omega) && ((cx->size() >= 2 && cy->size() < 2) == 0))
	    cx->addLearner(*leiter);
	  else
	    cy->addLearner(*leiter);
	}
	
      if((c1->size() > _omega || c2->size() > _omega) || 
	 (c1->size() < 2 && c2->size() < 2))
	die(__FILE__, __FUNCTION__, __LINE__, "messed up team generation");
      
      /* Get learners in offspring. */
      
      clearners1.clear();
      clearners2.clear();
      c1->members(&clearners1);
      c2->members(&clearners2);

#ifdef MYDEBUG
      cout << " c1";
      for(leiter = clearners1.begin(); leiter != clearners1.end(); leiter++)
	cout << " " << (**leiter);
      cout << " c2";
      for(leiter = clearners2.begin(); leiter != clearners2.end(); leiter++)
	cout << " " << (**leiter);
      cout << endl;
#endif
      
      /* If the offspring has the same learners as a parent, require that the 
	 offspring is mutated. */
		
      if(clearners1 == plearners1 || clearners1 == plearners2)
 	while(genTeams(t, c1) == 0);
      else
	genTeams(t, c1);
	
      if(clearners2 == plearners1 || clearners2 == plearners2)
 	while(genTeams(t, c2) == 0);
      else
 	genTeams(t, c2);
      
      /* Increment references in learners of final offspring. */
      
      clearners1.clear();
      clearners2.clear();
      c1->members(&clearners1);
      c2->members(&clearners2);

      for(leiter = clearners1.begin(), leiterend = clearners1.end();
	  leiter != leiterend; leiter++)
	(*leiter)->refInc();

      for(leiter = clearners2.begin(), leiterend = clearners2.end();
	  leiter != leiterend; leiter++)
	(*leiter)->refInc();

      /* Insert new teams. */

      M_.insert(c1);
      M_.insert(c2);

#ifdef MYDEBUG
      cout << "scm::genTeams t " << t << " parents " << *p1 << " " << *p2;
      cout << " generated " << *c1 << " " << *c2 << endl;
#endif
    }
}

/***********************************************************************************************************/

bool scm::genTeams(long t,
		   team *c)
{
  /* Whether the team has been changed by this method. */
  bool changedTeam = 0;
  /* If a learners is changed. */
  bool changedLearner;

  vector < learner * > lVec;
  vector < learner * > :: iterator veiter, veiterend;
  
  set < learner * > lSet;
  set < learner * > :: iterator seiter;
  //  int i;
  
  learner *lr;
  int left;
  
  //  int index;

  /* Retrieve learners in offspring and insert into vector. */
  c->members(&lSet);
  lVec.insert(lVec.begin(), lSet.begin(), lSet.end());
  
  /* We want to consider the learners in arbitrary order. */
  random_shuffle(lVec.begin(), lVec.end());
  
  /* How many learners were present originally. */
  left = lVec.size();

#ifdef MYDEBUG
  cout << "scm:genTeams " << *c << " delete";
#endif
  
  /* Delete learners from team (but keep them in lVec). */
  
  for(veiter = lVec.begin(), veiterend = lVec.end();
      (veiter != veiterend) && (left > 2); veiter++)
    {      
      if(drand48() < _pd) 
	{
	  c->removeLearner(*veiter);
	  left--;
	  changedTeam = 1;
#ifdef MYDEBUG
	  cout << " " << (*veiter)->id();
#endif
	}
    }

#ifdef MYDEBUG
  cout << " result " << *c << endl;
#endif
  
  /* Now mutate (even the deleted learners). */

  for(veiter = lVec.begin(), veiterend = lVec.end();
      (veiter != veiterend) && (left < _omega); veiter++)
    {
      if(drand48() < _pa)
	{
	  /* Add a mutated learner. */
	  
	  changedLearner = 0;
	  
	  lr = new learner(t, **veiter);
	  
	  /* Mutate bid. */
	  
	  changedLearner = lr->muBid(_pBidDelete, _pBidAdd, _pBidSwap, _pBidMutate, _maxProgSize);
	  
	  /* Mutate action. */

	  if(drand48() < _mua)
	    changedLearner = lr->muAction(((long) (drand48() * numActions()))) || changedLearner;

	  /* Keep only learner if changed. */
	  
	  if(changedLearner == 0)
	    {
	      delete lr;
	    }
	  else
	    {
	      c->addLearner(lr);
	      L_.insert(lr);
	      changedTeam = 1;
	      
	      left++;

#ifdef MYDEBUG
	      cout << "scm:genTeams added " << *lr << " from " << **veiter << endl;
#endif	      
	    }
	}
    }

// THE FOLLOWING SHOULD NOT HAPPEN!!!

//   /* Make sure don't get teams with fewer than two learners. */

//   while(c->size() < 2)
//     {
//       /* Pick a random learner in the population. */
//       index = (int) (drand48() * L_.size());
      
//       /* Advance to that learner. */
//       for(i = 0, seiter = L_.begin(); i < index; i++, seiter++);

//       /* Try to add the learner .*/
//       c->addLearner(*seiter);
      
// #ifdef MYDEBUG
//       cout << "scm:genTeams small " << c->size() << " added " << **seiter << endl;
// #endif
//     }

  if(c->size() < 2)
    die(__FILE__, __FUNCTION__, __LINE__, "c->size() < 2");
    
  return changedTeam;
}

/***********************************************************************************************************/

void scm::getDist(map < point *, vector < short > * > &dist)
{
  if(dist.empty() == 0)
    die(__FILE__, __FUNCTION__, __LINE__, "distinction map should be empty");
  
  vector < double > outcomes;
  double out;
  vector < short > *distvec;

  int i, j;
  int size = M_.size();
  
  /* Assuming that iterating through point and team population always in the same order
     (which is true for sets). */
  
  set < point * > :: iterator poiter, poiterend;
  set < team * > :: iterator teiter, teiterbegin, teiterend;
  
  teiterbegin = M_.begin();
  teiterend = M_.end();

  /* Build distinction vector for each point. */
  
  for(poiter = P_.begin(), poiterend = P_.end(); 
      poiter != poiterend; poiter++)
    {
      /* Collect outcomes. */
      
      outcomes.clear();
      
      for(teiter = teiterbegin; teiter != teiterend; teiter++)
	{
	  if((*teiter)->getOutcome(*poiter, &out) == 0)
	    die(__FILE__, __FUNCTION__, __LINE__, "outcome not found");
	  
	  outcomes.push_back(out);
	}

      /* Allocate distinction vector and insert into map. */

      distvec = new vector < short >;
      dist.insert(map < point *, vector < short > * > :: value_type(*poiter, distvec));

#ifdef MYDEBUG
      cout << "scm::getDist outcomes " << outcomes.size() << " = " << M_.size();
      for(i = 0; i < size; i++)
	cout << " " << outcomes[i];
      cout << endl;
#endif
      
      /* Calculate the distinctions. */
      
      for(i = 0; i < size; i++)
	for(j = 0; j < size; j++)
	  {
	    /* See if outcome i > j. */
	    if(outcomes[i] > outcomes[j] && isEqual(outcomes[i], outcomes[j]) == 0)
	      distvec->push_back(1);
	    else
	      distvec->push_back(0);
	  }
    }
}

/***********************************************************************************************************/

template < class ptype, class vtype > void scm::findParetoFront(map < ptype *, vector < vtype > * > &vecMap, 
								set < ptype * > &F,  /* Pareto front. */ 
								set < ptype * > &D,  /* Dominated front. */
								double epsilon)
{
  typename map < ptype *, vector < vtype > * > :: iterator veiter1, veiter2, veiterbegin, veiterend;
  vector < vtype > *v1, *v2;
  
  bool dom;
  bool equal;

  int i, j;
  
  for(i = 0, veiterbegin = vecMap.begin(), veiter1 = vecMap.begin(), veiterend = vecMap.end(); 
      veiter1 != veiterend; veiter1++, i++)
    {
      dom = 0;
      v1 = veiter1->second;
      
      for(j = 0, veiter2 = veiterbegin; 
	  dom == 0 && veiter2 != veiterend; veiter2++, j++)
	{
	  v2 = veiter2->second;
	  dom = dominated(*v1, *v2, equal, epsilon);

	  /* Also dominated if equal to a previously processed item. */
	  if(j < i && equal == 1)
	    dom = 1;

#ifdef MYDEBUG
	  if(dom == 1)
	    cout << "scm::findParetoFront " << veiter1->first->id() << " vecs" << vecToStr(*v1) << " yesdom " << veiter2->first->id() << " vecs" << vecToStr(*v2) << endl;
	  else
	    cout << "scm::findParetoFront " << veiter1->first->id() << " vecs" << vecToStr(*v1) << " nondom " << veiter2->first->id() << " vecs" << vecToStr(*v2) << endl;
#endif
	}
      
      if(dom == 0)
	F.insert(veiter1->first);
      else
	D.insert(veiter1->first);
    }

//   typename map < ptype *, vector < vtype > * > :: iterator veiter1, veiter2, veiterbegin, veiterend;
//   vector < vtype > *v1, *v2;
  
//   bool dom;
//   bool equal;
  
//   for(veiterbegin = vecMap.begin(), veiter1 = veiterbegin, veiterend = vecMap.end(); 
//       veiter1 != veiterend; veiter1++)
//     {
//       dom = 0;
//       v1 = veiter1->second;
      
//       for(veiter2 = veiterbegin; dom == 0 && veiter2 != veiterend; veiter2++)
// 	{
// 	  v2 = veiter2->second;
// 	  dom = dominated(*v1, *v2, equal, epsilon);

// #ifdef MYDEBUG
// 	  if(dom == 1)
// 	    cout << "scm::findParetoFront" << vecToStr(*v1) << " yesdominated" << vecToStr(*v2) << endl;
// 	  else
// 	    cout << "scm::findParetoFront" << vecToStr(*v1) << " nondominated" << vecToStr(*v2) << endl;
// #endif
// 	}
      
//       if(dom == 0)
// 	F.insert(veiter1->first);
//       else
// 	D.insert(veiter1->first);
//     }
}

/***********************************************************************************************************/

#define myfabs(x) ((x) <0? -(x) : (x))

template < class vtype > bool scm::dominated(vector < vtype > &is, /* Is this vector */
					     vector < vtype > &by, /* dominated by this vector. */
					     bool &equal, /* Whether or not they are equal. */
					     double epsilon)
{
  /* Assume higher outcomes better. */
  
  if(is.size() != by.size())
    die(__FILE__, __FUNCTION__, __LINE__, "outcome vectors do not match");

  typename vector < vtype > :: iterator isIter, byIter, endIter;

  /* Initially assume `is' is equal to 'by'. */
  equal = 1;
  
  for(isIter = is.begin(), byIter = by.begin(), endIter = is.end();
      isIter != endIter; isIter++, byIter++)
    {
      /* They are equal in this dimension. */
      if(myfabs(*isIter - *byIter) < epsilon) continue;

      /* At this point know they are not equal. */
      equal = 0;
      
      /* Not dominated since 'is' greater than 'by' in this dimension. */
      if(*isIter > *byIter) return 0;
    }  

  /* At this point, 'is' is never larger than 'by' (otherwise would have returned
     already), so if they are not equal 'by' must be larger than 'is' on some 
     dimension and therefore dominant. */

  return equal == 0;
}

/***********************************************************************************************************/

template <class ptype, class vtype > void scm::sharingScore(map < ptype *, vector < vtype > * > &outMap, 
							    map < ptype *, double > &score,
							    set < ptype * > &forThese, /* Calculate score for these members. */
							    set < ptype * > &wrtThese) /* Denominator w.r.t. these. */
{
  if(score.empty() == 0)
    die(__FILE__, __FUNCTION__, __LINE__, "score map should be empty");
  
  typename set < ptype * > :: iterator ptiter, ptiterend;

  /* Denominator in each dimension. */
  vector < vtype > nd;
  
  vector < vtype > *outvec;
  double sc;
  int i;
  
  int outvecsize = (outMap.begin()->second)->size();
  
  /* Initialize to 1 so that do not divide by zero. */
  nd.insert(nd.begin(), outvecsize, 1);
  
  /* Calculate denominators in each dimension. */

  for(ptiter = wrtThese.begin(), ptiterend = wrtThese.end();
      ptiter != ptiterend; ptiter++)
    {
      /* Get outcome vector. */
      outvec = (outMap.find(*ptiter))->second;
      
      for(i = 0; i < outvecsize; i++)
	nd[i] += (*outvec)[i];
    }
  
  for(ptiter = forThese.begin(), ptiterend = forThese.end(); 
      ptiter != ptiterend; ptiter++)
    {
      outvec = (outMap.find(*ptiter))->second;
      sc = 0;

      for(i = 0; i < outvecsize; i++)
	sc += ((double) (*outvec)[i] / nd[i]);
      
      score.insert(typename map < ptype *, double > :: value_type(*ptiter, sc));
    }

#ifdef MYDEBUG
  typename map < ptype *, double > :: iterator sciter;
  cout << "scm::sharingScore";
  for(sciter = score.begin(); sciter != score.end(); sciter++)
    cout << " " << sciter->first->id() << "/" << sciter->second;
  cout << endl;
#endif
}

/***********************************************************************************************************/

template < class ptype > void scm::selPareto(set < ptype * > &from, 
					     map < ptype *, double > &score,
					     int nrem,
					     set < ptype * > &toDel)
{
  typename set < ptype * > :: iterator ptiter, ptiterend;
  vector < ptype * > ptvec;
  
  for(ptiter = from.begin(), ptiterend = from.end(); 
      ptiter != ptiterend; ptiter++)
    {
      (*ptiter)->key((score.find(*ptiter))->second);
      ptvec.push_back(*ptiter);
    }
  
  partial_sort(ptvec.begin(), ptvec.begin() + nrem, ptvec.end(), lessThan < ptype > () );
  
  toDel.insert(ptvec.begin(), ptvec.begin() + nrem);
  
#ifdef MYDEBUG
  cout << "scm::selPareto " << nrem << "/" << from.size();
  for(int i = 0; i < ptvec.size(); i++)
    cout << " " << *ptvec[i] << "/" << (score.find(ptvec[i]))->second;
  cout << endl;
  
  cout << "scm::selPareto deleting";
  for(ptiter = toDel.begin(); ptiter != toDel.end(); ptiter++)
    cout << " " << **ptiter;
  cout << endl;
#endif
}

/***********************************************************************************************************/

void scm::selPoints(long t)
{
  /* Maps point->(distinction vector). */
  map < point *, vector < short > * > dist;
  map < point *, vector < short > * > :: iterator diiter, diiterend;

  set < point * > F, D;
  set < point * > :: iterator fiter, diter;

  set < point * > :: iterator poiter, poiterend;

  /* Fitness sharing score. */
  map < point *, double > score;

  /* Number of points to remove from F or D. */
  int nrem;
  /* Store points to be removed. */
  set < point * > toDel;

  /* How many points make it to next generation. */
  int keep = _Psize - _Pgap;
  
  /* Get distinctions and find Pareto front. */
  
  getDist(dist);

  findParetoFront(dist, F, D, 0.1);

  _pointFrontSize = F.size();
  
#ifdef MYDEBUG
  for(diiter = dist.begin(); diiter != dist.end(); diiter++)
    {
      cout << "scm::selPoints distinctions " << diiter->first->id() << " " << diiter->second->size();
      cout << vecToStr(*diiter->second);
      cout << endl;
    }
  
  cout << "scm::selPoints F";
  for(fiter = F.begin(); fiter != F.end(); fiter++)
    cout << " " << (*fiter)->id();
  cout << endl;
  
  cout << "scm::selPoints D";
  for(diter = D.begin(); diter != D.end(); diter++)
    cout << " " << (*diter)->id();
  cout << endl;
#endif

  if(F.size() == keep)
    {
      toDel = D;
    }
  else if(F.size() < keep)
    {
      /* Must include some points from D. */

      sharingScore(dist, score, D, P_);      
      nrem = D.size() - (keep - F.size());
      selPareto(D, score, nrem, toDel);
    }
  else 
    {
      /* Must discard some points from F (F.size() > keep). */
      
      sharingScore(dist, score, F, F);
      nrem = F.size() - keep;
      selPareto(F, score, nrem, toDel);
      
      /* After selPareto toDel contains points from F to be 
	 deleted, must add all points from D to toDel. */

      toDel.insert(D.begin(), D.end());
    }

#ifdef MYDEBUG
  cout << "scm::selPoints deleting";
#endif

  /* Mark points to be deleted. */

  for(poiter = toDel.begin(), poiterend = toDel.end(); 
      poiter != poiterend; poiter++)
    {
      if((*poiter)->gtime() != t) _pdom++;

      (*poiter)->mark();
      
#ifdef MYDEBUG
      cout << " " << **poiter;
#endif
    }

#ifdef MYDEBUG
  cout << endl;
#endif

  /* Free allocated array. */
      
  for(diiter = dist.begin(), diiterend = dist.end(); 
      diiter != diiterend; diiter++)
    delete diiter->second;
}

/***********************************************************************************************************/

void scm::selTeams(long t)
{
  /* Team outcome maps. */
  map < team *, vector < double > * > outMap;
  map < team *, vector < double > * > :: iterator omiter, omiterend;
  
  /* Pareto fronts. */
  set < team * > F, D;
  set < team * > :: iterator fiter, diter;
  
  set < team * > :: iterator teiter, teiterend;
  set < point * > :: iterator poiter, poiterbegin, poiterend;
  
  /* Sharing score. */
  map < team *, double > score;

  /* CURRENTLY THE SHARING SCORE CALCULATION IS OK BECAUSE EACH
     DIMENSION IS EITHER 0 OR 1. IF THE DIMENSIONS CAN TAKE ON
     DIFFERENT RANGES, MAY NEED TO NORMALIZE (THIS ASSUMES THAT EACH
     DIMENSION RECEIVES THE SAME WEIGHTING. */

  /* Number of teams to remove from F or D. */
  int nrem;
  
  /* Stores the teams to remove. */
  set < team * > toDel;
  
  double outcome;

  /* Number of teams that make it to the next generation. */
  int keep = _Msize - _Mgap;

  /* Populate the outcome map. */
  
  for(teiter = M_.begin(), teiterend = M_.end(), poiterbegin = P_.begin(), poiterend = P_.end();
      teiter != teiterend; teiter++)
    {
      omiter = outMap.insert(map < team *, vector < double > * > :: value_type(*teiter, new vector < double >)).first;
      
      for(poiter = poiterbegin; poiter != poiterend; poiter++)
	{
	  if((*teiter)->getOutcome(*poiter, &outcome) == 0)
	    die(__FILE__, __FUNCTION__, __LINE__, "cannot find outcome");
	  
	  omiter->second->push_back(outcome);
	}
    }
  
  /* Get the Pareto front. */

  findParetoFront(outMap, F, D, 0.1);

  _teamFrontSize = F.size();
  
#ifdef MYDEBUG
  for(omiter = outMap.begin(); omiter != outMap.end(); omiter++)
    cout << "scm::selTeams " << t << " " << omiter->first->id() << vecToStr(*omiter->second) << endl;
  
  cout << "scm::selTeams F";
  for(fiter = F.begin(); fiter != F.end(); fiter++)
    cout << " " << (*fiter)->id();
  cout << endl;
  
  cout << "scm::selTeams D";
  for(diter = D.begin(); diter != D.end(); diter++)
    cout << " " << (*diter)->id();
  cout << endl;
  
#endif
  
  if(F.size() == keep)
    {
      toDel = D;
    }
  else if(F.size() < keep)
    {
      /* Must include some teams from D. */

      sharingScore(outMap, score, D, M_);      
      nrem = D.size() - (keep - F.size());
      selPareto(D, score, nrem, toDel);
    }
  else 
    {
      /* Must discard some teams from F (F.size() > keep). */
      
      sharingScore(outMap, score, F, F);
      nrem = F.size() - keep;
      selPareto(F, score, nrem, toDel);
      
      /* After selPareto toDel contains teams from F to be 
	 deleted, must add all teams from D to toDel. */
      
      toDel.insert(D.begin(), D.end());
    }

#ifdef MYDEBUG
  cout << "scm::selTeams deleting";
#endif

  /* Delete teams from toDel. */
  
  for(teiter = toDel.begin(), teiterend = toDel.end(); 
      teiter != teiterend; teiter++)
    {
      if((*teiter)->gtime() != t) _mdom++;
      
      /* Unlike points we remove right away from the population. */
      M_.erase(*teiter);
      
#ifdef MYDEBUG
      cout << " " << **teiter;
#endif
      
      delete *teiter;
    }

#ifdef MYDEBUG
  cout << endl;
#endif
  
  /* Free outcome vectors. */
  
  for(omiter = outMap.begin(), omiterend = outMap.end();
      omiter != omiterend; omiter++)
    delete omiter->second;
}

/***********************************************************************************************************/

void scm::cleanup()
{
  /* Delete points marked for deletion. */
  /* Delete learners that are no longer referenced. */

  set < point * > :: iterator poiter, poiterend;
  set < team * > :: iterator teiter, teiterbegin, teiterend;
  set < learner * > :: iterator leiter, leiterend;
  
  vector < point * > pointvec;
  vector < learner * > learnervec;
  
  int size;
  int i;

  /* Collect points into pointvec. */

  for(poiter = P_.begin(), poiterend = P_.end(); 
      poiter != poiterend; poiter++)
    pointvec.push_back(*poiter);

  /* Delete marked points. */
  
  size = pointvec.size();
  for(i = 0, teiterbegin = M_.begin(), teiterend = M_.end(); i < size; i++)
    {
      if(pointvec[i]->marked() == 1)
	{
	  /* This point is marked for deletion. */

	  /* Delete outcomes for this point. */
	  
	  for(teiter = teiterbegin; teiter != teiterend; teiter++)
	    (*teiter)->deleteOutcome(pointvec[i]);
	  
	  /* Get rid of this point. */
	  
	  P_.erase(pointvec[i]);
	  delete pointvec[i];
	}
    }

  /* Collect learners into learnervec. */
  
  for(leiter = L_.begin(), leiterend = L_.end(); 
      leiter != leiterend; leiter++)
    learnervec.push_back(*leiter);

  /* Delete learners with zero references. */
  
  size = learnervec.size();
  for(i = 0; i < size; i++)
    {
      if(learnervec[i]->refs() == 0)
	{
	  /* Zero references, delete this learner. */
	  
	  L_.erase(learnervec[i]);
	  delete learnervec[i];
	}
    }
  
#ifdef MYDEBUG
  int sumTeamSizes, nrefs, sumNumOutcomes;
  
  cout << "scm::cleanup ";
  cout << P_.size() << " points, " << L_.size() << " learners, " << M_.size() << " teams";
  
  for(teiter = M_.begin(), sumTeamSizes = sumNumOutcomes = 0; teiter != M_.end(); teiter++)
    {
      sumTeamSizes += (*teiter)->size();
      sumNumOutcomes += (*teiter)->numOutcomes();
    }
  
  for(leiter = L_.begin(), nrefs = 0; leiter != L_.end(); leiter++)
    nrefs += (*leiter)->refs();
  
  cout << ", sumTeamSizes " << sumTeamSizes << ", nrefs " << nrefs << ", sumNumOutcomes " << sumNumOutcomes;
  cout << endl;

  if(sumTeamSizes != nrefs || sumNumOutcomes != (_Msize - _Mgap) * (_Psize - _Pgap))
    die(__FILE__, __FUNCTION__, __LINE__, "something messed up during cleanup");
  
#endif
}

/***********************************************************************************************************/

void scm::finalize()
{
  set < team * > :: iterator teiter;
  set < point * > :: iterator poiter;
  set < learner * > :: iterator leiter;
  
  for(teiter = M_.begin(); teiter != M_.end(); teiter++)
    delete *teiter;
  
  for(poiter = P_.begin(); poiter != P_.end(); poiter++)
    delete *poiter;

  for(leiter = L_.begin(); leiter != L_.end(); leiter++)
    delete *leiter;
}

/***********************************************************************************************************/

void scm::go()
{
  double sys1, usr1, sys2, usr2;
  long t;
  
  /* Get starting time. */
  if(getusage(sys1, usr1) == 0)
    die(__FILE__, __FUNCTION__, __LINE__, "cannot get rusage");
  
  set < team * > :: iterator teiter, teiterend;
  set < point * > :: iterator poiter, poiterend;

  /* Initialization. */
  
  initPoints();
  initTeams();

  /* Evaluate initial set of teams. */
  
  for(poiter = P_.begin(), poiterend = P_.end();
      poiter != poiterend; poiter++)
    for(teiter = M_.begin(), teiterend = M_.end();
	teiter != teiterend; teiter++)
      evaluate(*teiter, *poiter);

  /* Main loop. */
  
  for(t = 0; t < _t; t++)
    { 
#ifdef MYDEBUG
      cout << "scm:go " << t << " points";
      for(poiter = P_.begin(); poiter != P_.end(); poiter++)
	cout << " " << **poiter;
      cout << endl;

      cout << "scm:go " << t << " teams";
      for(teiter = M_.begin(); teiter != M_.end(); teiter++)
	cout << " " << **teiter;
      cout<< endl;
#endif
      
      genPoints(t);
      genTeams(t);

      for(poiter = P_.begin(), poiterend = P_.end(); 
	  poiter != poiterend; poiter++)	
	{
	  for(teiter = M_.begin(), teiterend = M_.end(); 
	      teiter != teiterend; teiter++)
	    {
	      /* Evaluate only if created this generation. */

	      if((*poiter)->gtime() == t || (*teiter)->gtime() == t)
		evaluate(*teiter, *poiter);
	    }
	}
      
      /* Select members into the next generation. */
      
      selPoints(t);
      selTeams(t);
      cleanup();

      /* Record some stats. */
      
      if(t % _statMod == 0)
	stats(t);
    }
  
  /* Record final stats. */
  
  stats(t);

  /* Record training time. */
  
  if(getusage(sys2, usr2) == 0)
    die(__FILE__, __FUNCTION__, __LINE__, "cannot get rusage");
  
  cout << "rusage sys1 = " << sys1 << " sys1 = " << usr1 << " sys1 = " << (sys1 + usr1);
  cout << " sys2 = " << sys2 << " sys2 " << usr2 << " sys2 = " << (sys2 + usr2);
  cout << " traintime = " << (sys2 + usr2) - (sys1 + usr1) << endl;

  /* Test the final population. */
  
  test();
  
  /* Final cleanup. */

  finalize();
}

/***********************************************************************************************************/

scmExplicit::scmExplicit(map < string, string > &args)
  : scm(args)
{
  string trainSetName, testSetName;
  long trainSetSize, testSetSize;
  int setDim;
  string envType;

  map < string, string > :: iterator maiter;
  
  if((maiter = args.find("trainSetName")) == args.end())
    die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg trainSetName");
  
  trainSetName = maiter->second;

  if((maiter = args.find("testSetName")) == args.end())
    die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg testSetName");
  
  testSetName = maiter->second;

  if((maiter = args.find("trainSetSize")) == args.end())
    die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg trainSetSize");
  
  trainSetSize = stringToLong(maiter->second);

  if((maiter = args.find("testSetSize")) == args.end())
    die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg testSetSize");
  
  testSetSize = stringToLong(maiter->second);

  if((maiter = args.find("setDim")) == args.end())
    die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg setDim");
  
  setDim = stringToInt(maiter->second);
  
  if((maiter = args.find("envType")) == args.end())
    die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg envType");
  
  envType = maiter->second;
  
  cout << "arg trainSetName " << trainSetName << endl;
  cout << "arg testSetName " << testSetName << endl;
  cout << "arg trainSetSize " << trainSetSize << endl;
  cout << "arg testSetSize " << testSetSize << endl;
  cout << "arg setDim " << setDim << endl;
  cout << "arg envType " << envType << endl;
  
  if(setDim < 1 || setDim > INPUTS)
    die(__FILE__, __FUNCTION__, __LINE__, "bad arg setDim < 1 || setDim > INPUTS");
  
  if(trainSetSize < 1 || testSetSize < 1)
    die(__FILE__, __FUNCTION__, __LINE__, "bad arg setSize < 1 || testSetSize < 1");

  if(envType == "datasetEnv")
    {
      _trainEnv = new datasetEnv(trainSetName, setDim, trainSetSize);
      _testEnv = new datasetEnv(testSetName, setDim, testSetSize);
      cout << "arg envType datasetEnv" << endl;
    }
  else
    {
      die(__FILE__, __FUNCTION__, __LINE__, "bad arg envType");
    }
  
  _numActions = _trainEnv->numLabels();

  if(_numActions > _omega)
    die(__FILE__, __FUNCTION__, __LINE__, "numActions > omega");

  if(_trainEnv->numLabels() != _testEnv->numLabels())
    cout << "WARNING different number of labels in training and test sets" << endl;
  
  for(int i = 0; i < _numActions; i++)
    if(_trainEnv->getLabel(i) != _testEnv->getLabel(i))
      die(__FILE__, __FUNCTION__, __LINE__, "labels do not match");

  cout << "arg numActions train/test " << _numActions << "/" << _testEnv->numLabels() << endl;
  
  if(_numActions < 2)
    die(__FILE__, __FUNCTION__, __LINE__, "bad arg numActions < 2");  
}

/***********************************************************************************************************/

scmExplicit::~scmExplicit()
{
  delete _trainEnv;
  delete _testEnv;
}

/***********************************************************************************************************/

void scmExplicit::initPoints()
{
  /* The number of points to initialize. */
  int keep = _Psize - _Pgap;
  
  set < long > usedIds;
  long label;
  point *pt;

  /* Count the number of points of each label. */
  map < long, long > counts;

  for(int i = 0; i < _trainEnv->numLabels(); i++)
    counts.insert(map < long, long > :: value_type (_trainEnv->getLabel(i), 0));
  
  while(P_.size() < keep)
    {
      do
	{
	  /* Get random label so long as don't already have all points of that label. */
	  label = _trainEnv->getLabel((int) (drand48() * _numActions));
	} while(counts[label] == _trainEnv->getLabelCount(label));

      pt = _trainEnv->initUniformPointLabel(-1, usedIds, label);
      
      if(pt == 0)
	die(__FILE__, __FUNCTION__, __LINE__, "cannot get point");     
      
      usedIds.insert(pt->id());
      P_.insert(pt);
      
      counts[label]++;
      
#ifdef MYDEBUG
      cout << "scmExplicit::initPoints added " << *pt << " P_.size() " << P_.size() << endl;
#endif
    }

//   /* The number of points to initialize. */
//   int keep = _Psize - _Pgap;
  
//   set < long > usedIds;
//   long label;
//   point *pt;
  
//   while(P_.size() < keep)
//     {
//       label = _trainEnv->getLabel((int) (drand48() * _numActions));
//       pt = _trainEnv->initUniformPointLabel(-1, usedIds, label);
//       if(pt != 0)
// 	{
// 	  usedIds.insert(pt->id());
// 	  P_.insert(pt);
	  
// #ifdef MYDEBUG
// 	  cout << "scmExplicit::initPoints added " << *pt << " P_.size() " << P_.size() << endl;
// #endif
// 	}
//     }
}

/***********************************************************************************************************/

void scmExplicit::genPoints(long t)
{
  set < long > usedIds;
  long label;
  point *pt;
  
  set < point * > :: iterator poiter, poiterend;

  /* Count the number of points of each label. */
  map < long, long > counts;
  map < long, long > :: iterator coiter;

  for(int i = 0; i < _trainEnv->numLabels(); i++)
    counts.insert(map < long, long > :: value_type (_trainEnv->getLabel(i), 0));
  
  for(poiter = P_.begin(), poiterend = P_.end(); 
      poiter != poiterend; poiter++)
    {
      usedIds.insert((*poiter)->id());
      
      if((coiter = counts.find((*poiter)->label())) == counts.end())
	die(__FILE__, __FUNCTION__, __LINE__, "bad label");
      
      (coiter->second)++;
    }

#ifdef MYDEBUG
  cout << "scmExplicit::genPoints counts";
  for(coiter = counts.begin(); coiter != counts.end(); coiter++)
    cout << " " << coiter->first << "->" << coiter->second;
  cout << endl;
#endif
  
  while(P_.size() < _Psize)
    {
      do
	{
	  /* Get random label so long as don't already have all points of that label. */
	  label = _trainEnv->getLabel((int) (drand48() * _numActions));
	} while(counts[label] == _trainEnv->getLabelCount(label));
      
      pt = _trainEnv->initUniformPointLabel(t, usedIds, label);

      if(pt == 0)
	die(__FILE__, __FUNCTION__, __LINE__, "cannot get point");     
      
      usedIds.insert(pt->id());
      P_.insert(pt);

      counts[label]++;
      
#ifdef MYDEBUG
      cout << "scmExplicit::genPoints added " << *pt << " P_.size() " << P_.size() << endl;
#endif
    }

//   set < long > usedIds;
//   long label;
//   point *pt;
  
//   set < point * > :: iterator poiter, poiterend;
  
//   for(poiter = P_.begin(), poiterend = P_.end(); 
//       poiter != poiterend; poiter++)
//     usedIds.insert((*poiter)->id());
  
//   while(P_.size() < _Psize)
//     {
//       label = _trainEnv->getLabel((int) (drand48() * _numActions));
//       pt = _trainEnv->initUniformPointLabel(t, usedIds, label);
//       if(pt != 0)
// 	{
// 	  usedIds.insert(pt->id());
// 	  P_.insert(pt);
	  
// #ifdef MYDEBUG
// 	  cout << "scmExplicit::genPoints added " << *pt << " P_.size() " << P_.size() << endl;
// #endif
// 	}
//     }
}

/***********************************************************************************************************/

void scmExplicit::test()
{
  if(M_.size() < 1)
    die(__FILE__, __FUNCTION__, __LINE__, "no teams to test");     

  ostringstream oss;

  oss << _seed;

  set < team * > :: iterator teiter, maxiter;

  double score;
  double maxScore = -1;

  bool equal;
  
  for(teiter = M_.begin(); teiter != M_.end(); teiter++)
    {
      score = _trainEnv->test(*teiter, oss.str());
      
      if(score < 0)
	die(__FILE__, __FUNCTION__, __LINE__, "bad score");     

      equal = isEqual(score, maxScore, 1e-7);
      
      if(((equal == 0) && (score > maxScore)) ||
	 ((equal == 1) && ((*teiter)->size() < (*maxiter)->size())))
	{
	  /* Select this team if the score is greater than maxScore or if the scores are
	     the same but the size of this team is smaller. */
	  
	  maxScore = score;
	  maxiter = teiter;
	}
    }
  
  _testEnv->test(*maxiter, oss.str());
}

/***********************************************************************************************************/

void scmExplicit::stats(long t)
{
  int sumTeamSizes = 0;
  int nrefs = 0;
  int sumNumOutcomes = 0;

  /* Labels in P_. */
  vector < long > labelCount;
  /* Actions in L_. */
  vector < long > actionCount;

  /* Quartiles for team sizes. */
  vector < int > msize;
  int mq1 = (int) (M_.size() * 0.25);
  int mq2 = (int) (M_.size() * 0.5);
  int mq3 = (int) (M_.size() * 0.75);
  
  set < point * > :: iterator poiter;
  set < learner * > :: iterator leiter;
  set < team * > :: iterator teiter;
  
  labelCount.insert(labelCount.begin(), _numActions, 0);
  actionCount.insert(actionCount.begin(), _numActions, 0);
  
  for(poiter = P_.begin(); poiter != P_.end(); poiter++)
    labelCount[_trainEnv->getLabelIndex((*poiter)->label())]++;

  for(leiter = L_.begin(); leiter != L_.end(); leiter++)
    {
      actionCount[(*leiter)->action()]++;
      nrefs += (*leiter)->refs();
    }
  
  for(teiter = M_.begin(); teiter != M_.end(); teiter++)
    {
      msize.push_back((*teiter)->size());
      sumTeamSizes += (*teiter)->size();
      sumNumOutcomes += (*teiter)->numOutcomes();
    }
  
  sort(msize.begin(), msize.end());
  
  cout << "scm::stats " << _seed << " " << t;
  cout << " mdom " << _mdom;
  cout << " pdom " << _pdom;
  cout << " Lsize " << L_.size();

  cout << " labels";
  for(int i = 0; i < _numActions; i++)
    cout << " " << _trainEnv->getLabel(i);
  
  cout << " points";
  for(int i = 0; i < labelCount.size(); i++)
    cout << " " << labelCount[i];

  cout << " learners";
  for(int i = 0; i < actionCount.size(); i++)
    cout << " " << actionCount[i];
  
  cout << " msize " << msize[mq1] << " " << msize[mq2] << " " << msize[mq3];

  cout << " pointFront " << _pointFrontSize << " teamFront " << _teamFrontSize;

  cout << endl;

  /* Preform the following check to make sure that the number of
     references recoreded in the learners is actually equal to the sum
     of the team sizes and that the outcome counts equal the number of
     points by the number of teams. */

  if(sumTeamSizes != nrefs || sumNumOutcomes != (_Msize - _Mgap) * (_Psize - _Pgap))
    die(__FILE__, __FUNCTION__, __LINE__, "something does not add up"); 
}






