
#ifndef point_hpp
#define point_hpp

#include <vector>
#include <map>

#include "misc.hpp"

using namespace std;

class point
{
  long _id;
  long _gtime;
  map < long, double > _state;
  long _label;
  int _dim;

  /* For sorting. */
  double _key;
  
  bool _marked;
  
public:

  point(long, int, long, const map <long, double> *, long);

  inline int dim() 
  { return _dim; }
  inline void state(map < long, double > &v) 
  { v = _state; }
  inline long label() 
  { return _label; }
  inline long id() 
  { return _id; }
  inline long gtime() 
  { return _gtime; }

  inline double key() 
  { return _key; }
  inline void key(double key) 
  { _key = key; }

  inline bool marked() 
  { return _marked; }
  inline void mark() 
  { _marked = 1; }
  inline void unmark() 
  { _marked = 0; }

  friend ostream & operator<<(ostream &, const point &);
};

#endif
