#!/usr/bin/perl 
use Storable qw(dclone); 
use strict;

my $i;
my $ind_counter = 0;

while($i = <>){
  if($i =~ m/rate/){
    while(!($i eq "\n")){
      print $i;
      $i = <>;
    }
    $ind_counter = 0;
  }
  if($i =~ m/\[/){
    print "\nIndividual $ind_counter\n";
    print "$i";
    $ind_counter++;
    parseIndiv();
  }
  print "\n";
}

#replace for each new problem set...
sub problemSpecificInputMask{
  my $r = shift;
  my $tmp;
  while($r =~ m/I([0-9]+)\)/g){
    $tmp = $1;
    $r =~ s/I$1/Ngram\#$tmp/g; 
  }
  return $r;
}


sub parseIndiv{
  my @stack = ();
  while(!(($i= <>)  =~ m/Ind/)){
    if(!$i){
      last;
    }
    push(@stack, $i);
  } 
  my $r =  parseStack(0, @stack);
  print problemSpecificInputMask($r);
}

sub parseStack{
  my $number = shift;
  my @stack = @_;
  my $topOfStack = pop(@stack);
  my $mode = "no";
  while($topOfStack){
    if($topOfStack =~ m/R(\d)/){
      if($1 == $number){
        $mode = "yes";
        last;
      } 
    }
    $topOfStack = pop(@stack);
  }
  if($mode eq "yes"){
    return " ".traceStack($topOfStack, @stack);
  }
  else{
    return "0";
  }
}


sub traceStack{
  my $topOfStack = shift;
  #print $topOfStack;
  my @stack = @_;
  my $r_val = "";
  my $x;
  my $y;
  my$z;
  if($topOfStack =~ m/R(\d) = R\d (\S) R(\d)/){
    #print STDERR "$1 $2 $3\n";
    $x = $1; $y = $2; $z = $3;
    $r_val = parseStack($x, deepCopy(@stack))." ".$y." ";
    my $r_val2 = parseStack($z, deepCopy(@stack));
    $r_val =$r_val.$r_val2;
  } 
  elsif($topOfStack =~ m/R(\d) = (\S\S\S) R(\d)/){
    $x = $1; $y = $2; $z = $3;
    #print STDERR "$1 $2 $3\n";
    $r_val = $y." ".parseStack($z, deepCopy(@stack));
  }
  elsif($topOfStack =~ m/R(\d) = R\d (.) I(\d+)/){
    $x = $1; $y = $2; $z = $3;
    #print STDERR "$1 $2 $3\n";
    $r_val = parseStack($x, deepCopy(@stack))." ".$y." I".$z;
  }
  elsif($topOfStack =~ m/R(\d) = (\S+) I(\d+)/){
    $x = $1; $y = $2; $z = $3;
    #print STDERR "$1 $2 $3\n";
    $r_val = $y." I".$z;
  }
  return "($r_val)"; 
}

sub deepCopy{
  my @tmp = @{dclone(\@_)};
  return @tmp;
}



