/*********************indiv_parser.c**************
 * Parses a linear GP individual comprised of 3-byte hex instructions
 * into textual representation.
**************************************************/

#include <string.h>
#include <stdio.h>
#include <stdlib.h>

int main(int argc, char* argv[]){
  int ATTRIB;
  sscanf(argv[1], "%d", &ATTRIB);
  printf("%d\n", ATTRIB);
  unsigned int bytes;
  int start=1, count=0;
  char b[BUFSIZ];
  while(strcmp(b, "\n")){
    fgets(b, BUFSIZ, stdin);
    printf("%s", b);
  }
  while(fgets(b, BUFSIZ, stdin)){
    if(!strcmp(b,"\n")){
      start = 1;
      continue; 
    }
    if(start){
      printf("Individual %d:\n", count);
      start = 0;
      count++;
      printf("%s\n", b);
      continue;
    }
    if(sscanf(b, "%x", &bytes) == 0)
      continue;
    
    unsigned char mode = (bytes & 0x00000001);
    unsigned char op = (bytes & 0x0000000E) >> 1; 
    unsigned char dst = (bytes & 0x00000070) >> 4;
    unsigned int src = (bytes & 0xFFFF80) >> 7;
    if(mode == 0)
      src = src%8;
    else
      src = src%ATTRIB;
    char* op_word;
    switch(op){
      case 0: op_word = " + "; break;
      case 1: op_word = " - "; break;
      case 2: op_word = " * "; break;
      case 3: op_word = " / "; break;
      case 4: op_word = " % "; break;
      case 5: op_word = "cos "; break;
      case 6: op_word = "exp "; break;
      case 7: op_word = "log "; break;
    }  
    if(op <= 4 && mode == 0)
      printf("R%d = R%d%sR%d\n", dst, dst, op_word, src);
    if(op > 4 && mode == 0)
      printf("R%d = %sR%d\n", dst, op_word, src);
    if(op <= 4 && mode == 1)
      printf("R%d = R%d%sI%d\n", dst, dst, op_word, src);
    if(op > 4 && mode == 1)
      printf("R%d = %sI%d\n",  dst, op_word, src);
  }
 
}
